# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Summary:	HTML validation module (and script)
Name:		perl-HTML-Lint
Version:	2.32
Release:	19.%{__distinit}%{__distvers}
License:	Artistic-2.0
URL:		https://metacpan.org/release/HTML-Lint
Source0:	https://cpan.metacpan.org/modules/by-module/HTML/HTML-Lint-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(constant)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(HTML::Entities)
BuildRequires:	perl(HTML::Parser) >= 3.47
BuildRequires:	perl(HTML::Tagset) >= 3.03
BuildRequires:	perl(parent)
BuildRequires:	perl(strict)
BuildRequires:	perl(Test::Builder)
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
# Script Runtime
BuildRequires:	perl(Getopt::Long)
BuildRequires:	perl(LWP::Simple)
# Test Suite
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(Test::Builder::Tester)
BuildRequires:	perl(Test::More)
# Optional Tests
BuildRequires:	perl(Test::Pod) >= 1.14
BuildRequires:	perl(Test::Pod::Coverage) >= 1.04
# Runtime
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(LWP::Simple)

# Supersede old weblint package
Obsoletes:	weblint < 1.9.4
Provides:	weblint = %{version}

%description
HTML::Lint is a pure-Perl HTML parser and checker for syntactic legitimacy.

The "weblint" script is now pretty much a wrapper around the HTML::Lint
module.

You can also look into Apache::Lint, which is a mod_perl wrapper around
HTML::Lint.

%package -n perl-Test-HTML-Lint
License:	Artistic-2.0
Summary:	Test::More-style wrapper around HTML::Lint
Requires:	%{name} = %{version}-%{release}

%description -n perl-Test-HTML-Lint
Test::HTML::Lint lets you automate HTML checking by providing a convenient
wrapper for HTML::Lint. It is built with Test::Builder and plays happily with
Test::More and friends.

%prep
%setup -q -n HTML-Lint-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%doc Changes README.md
%{_bindir}/weblint
%{perl_vendorlib}/HTML/
%{_mandir}/man3/HTML::Lint.3*
%{_mandir}/man3/HTML::Lint::Error.3*
%{_mandir}/man3/HTML::Lint::HTML4.3*
%{_mandir}/man3/HTML::Lint::Parser.3*

%files -n perl-Test-HTML-Lint
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::HTML::Lint.3*

%changelog
* Sun Jul 21 2024 Paul Howarth <paul@city-fan.org> - 2.32-19
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Tue Jan 30 2024 Paul Howarth <paul@city-fan.org> - 2.32-18
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jul 21 2023 Paul Howarth <paul@city-fan.org> - 2.32-16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Mon Jan 23 2023 Paul Howarth <paul@city-fan.org> - 2.32-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Wed Nov 30 2022 Paul Howarth <paul@city-fan.org> - 2.32-14
- Use SPDX-format license tag

* Mon Jul 25 2022 Paul Howarth <paul@city-fan.org> - 2.32-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Tue Jun  7 2022 Paul Howarth <paul@city-fan.org> - 2.32-12
- Perl 5.36 rebuild

* Wed Jan 26 2022 Paul Howarth <paul@city-fan.org> - 2.32-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Sat Jul 24 2021 Paul Howarth <paul@city-fan.org> - 2.32-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild
- Fix dist tags for Alma and Rocky Linux

* Tue May 25 2021 Paul Howarth <paul@city-fan.org> - 2.32-9
- Perl 5.34 rebuild

* Tue Feb  2 2021 Paul Howarth <paul@city-fan.org> - 2.32-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Wed Jul 29 2020 Paul Howarth <paul@city-fan.org> - 2.32-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Mon Jun 29 2020 Paul Howarth <paul@city-fan.org> - 2.32-6
- Perl 5.32 rebuild

* Fri Jan 31 2020 Paul Howarth <paul@city-fan.org> - 2.32-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Mon Aug 12 2019 Paul Howarth <paul@city-fan.org> - 2.32-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Mon Jun 10 2019 Paul Howarth <paul@city-fan.org> - 2.32-3
- Perl 5.30 rebuild

* Tue Feb 12 2019 Paul Howarth <paul@city-fan.org> - 2.32-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Mon Jun 25 2018 Paul Howarth <paul@city-fan.org> - 2.32-1
- Update to 2.32
  - Allow "weblint -" to read from STDIN
- Switch from search.cpan.org to metacpan.org

* Mon Feb 19 2018 Paul Howarth <paul@city-fan.org> - 2.30-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Mon Jan  8 2018 Paul Howarth <paul@city-fan.org> - 2.30-1
- Update to 2.30
  - Adds checking of entities in attributes, not just text
  - Calling ->parsefile() would generate an error (GH#58)
  - Removed the text-invalid-entity and attr-invalid-entity, which were for
    entities that had an invalid numeric value, anything greater than &#65536;
    there is no longer a restriction on the numeric values of HTML entities
    (GH#60)
  - Prepare for perl 5.26.0, which removes '.' from @INC
  - Fix disttest target
  - Many Perl::Critic cleanups

* Fri Jul 28 2017 Paul Howarth <paul@city-fan.org> - 2.26-4
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Fri Dec 30 2016 Paul Howarth <paul@city-fan.org> - 2.26-1
- Update to 2.26
  - Added two new types of errors to let you know you're using the API
    incorrectly; if you neglect to call ->parse or ->eof, you'll get an error
    returned in the list of errors from ->errors()
  - Test::HTML::Lint::html_fragment_ok() was not properly calling ->eof
  - html_fragment_ok() was not properly excluding document-level errors; it was
    effectively the same as html_ok()

* Thu Dec  8 2016 Paul Howarth <paul@city-fan.org> - 2.24-1
- Update to 2.24
  - Added detection of unknown HTML entities, like "known &unclosed &entities
    are not found"; this also fixes the case where HTML::Lint gets confused by
    an entity like "&sup2;", which it thought was an unterminated "&sup;"
    entity
  - Errors of the type doc-tag-required did not come out in any defined order;
    they are now sorted by tag name
  - Handle some warnings that get thrown if certain values are undef
  - Handle characters that are not handled by HTML::Entities (GH#13)

* Sat May 21 2016 Paul Howarth <paul@city-fan.org> - 2.22-7
- BR: perl-generators where possible
- Simplify find command using -delete

* Wed Feb 10 2016 Paul Howarth <paul@city-fan.org> - 2.22-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Sat Jun 20 2015 Paul Howarth <paul@city-fan.org> - 2.22-4
- Perl 5.22 rebuild

* Tue Apr 14 2015 Paul Howarth <paul@city-fan.org> - 2.22-2
- Rebuild

* Wed Apr  8 2015 Paul Howarth <paul@city-fan.org> - 2.22-1
- Update to 2.22
  - Previously, html_ok() would not check the entire structure of a web page to
    check for <html>, <head>, <title> and <body> tags; now it will
  - If you want to check fragments of HTML for validity but know that they are
    not valid HTML documents on their own, use the new html_fragment_ok()
  - Added new error, elem-input-alt-missing, that warns of <input type="image">
    tags that are missing an alt="" attribute; this helps for accessibility to
    make sure that any images have alternate text for screen readers
  - Added ability to modify HTML::Lint's table of known tags and attributes, so
    you could add proprietary/new tags if you wanted
  - Test::HTML::Lint::html_ok() would not call the HTML::Lint eof() method,
    which meant it wouldn't do document-wide tests
- Classify buildreqs by usage
- Add upstream fix for hash randomization causing test failures
  (https://github.com/petdance/html-lint/issues/39)

* Sun Aug 31 2014 Paul Howarth <paul@city-fan.org> - 2.20-9
- Perl 5.20 rebuild

* Wed Jun 11 2014 Paul Howarth <paul@city-fan.org> - 2.20-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Mon Aug  5 2013 Paul Howarth <paul@city-fan.org> - 2.20-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sat Aug  3 2013 Paul Howarth <paul@city-fan.org> - 2.20-6
- Perl 5.18 rebuild

* Sun Feb 24 2013 Paul Howarth <paul@city-fan.org> - 2.20-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Tue Jul 24 2012 Paul Howarth <paul@city-fan.org> - 2.20-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu Jun 28 2012 Paul Howarth <paul@city-fan.org> - 2.20-3
- BR: perl(base) and perl(constant)

* Fri Apr 13 2012 Paul Howarth <paul@city-fan.org> - 2.20-2
- Bump and rebuild

* Fri Apr  6 2012 Paul Howarth <paul@city-fan.org> - 2.20-1
- Update to 2.20
  - Added comment-directives to disable specific errors in your HTML
  - Added check for unknown entities, such as "&foo;"
  - Added check for unclosed entitities, such as "&amp" without the closing
    semicolon
  - Added a check for a bare ampersand that should be written as &amp;
- BR: perl(Exporter), perl(HTML::Entities), perl(Test::Builder) and
  perl(Test::More)
- Correct license for perl-Test-HTML-Lint, which is also Artistic 2.0
- Drop %%defattr, redundant since rpm 4.4
- Don't need to remove empty directories from buildroot
- Package new manpage for HTML::Lint::Parser

* Wed Jan 18 2012 Paul Howarth <paul@city-fan.org> - 2.10-2
- Spec clean-up:
  - One buildreq per line
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Drop redundant definition of %%{perl_vendorlib}
  - Use %%{_fixperms} rather than our own chmod incantation

* Tue Dec  6 2011 Paul Howarth <paul@city-fan.org> - 2.10-1
- Update to 2.10
  - HTML::Lint is now explicitly licensed under Artistic License 2.0
  - Tags that were self-closed (such as <img src="blah.jpg" />) were being
    ignored; this has been fixed
- Bump HTML::Parser version requirement to 3.47 for empty_element_tags support

* Mon Jun 27 2011 Paul Howarth <paul@city-fan.org> - 2.06-8
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Sun Dec 19 2010 Paul Howarth <paul@city-fan.org> - 2.06-7
- Rebuild to fix problems with vendorarch/lib (#661697)

* Sat Jun 26 2010 Paul Howarth <paul@city-fan.org> - 2.06-6
- Split Test::HTML::Lint into its own subpackage as it pulls in perl-devel
- Remove redundant manual requires on perl(HTML::Parser) and perl(HTML::Tagset)

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> - 2.06-5
- Rebuild for perl 5.12.1 in Rawhide

* Thu May 13 2010 Paul Howarth <paul@city-fan.org> - 2.06-4
- Fix dist tag for RHEL-6 Beta

* Sun Feb 21 2010 Paul Howarth <paul@city-fan.org> - 2.06-3
- Dist tag for Rawhide no longer needs special-casing
- Replace perl-libwww-perl dependency with more precise perl(LWP::Simple) dependency

* Thu Sep 10 2009 Paul Howarth <paul@city-fan.org> - 2.06-2
- Define RPM macros in global scope
- Fix provides so we don't self-obsolete

* Fri Dec 19 2008 Paul Howarth <paul@city-fan.org> - 2.06-1
- Update to 2.06
- Tweak dist tag macros to work on current Rawhide with three-part releasenum

* Tue Jun  3 2008 Paul Howarth <paul@city-fan.org> - 2.04-1
- Update to 2.04

* Tue Mar 11 2008 Paul Howarth <paul@city-fan.org> - 2.02-4
- Clarify license as GPL version 1 or later, of Artistic (i.e. same as perl)

* Mon Jun  4 2007 Paul Howarth <paul@city-fan.org> - 2.02-3
- Fix dist tag for Fedora 7 onwards
- Fix argument order for find with -depth
- Add version number to obsoletes/provides for weblint
- Add buildreq perl(ExtUtils::MakeMaker)

* Fri Sep  1 2006 Paul Howarth <paul@city-fan.org> - 2.02-2
- Fix distribution tags for development releases
- Define %%{__id_u} in a more portable way

* Fri Nov  4 2005 Paul Howarth <paul@city-fan.org> - 2.02-1
- Update to 2.02
- Use search.cpan.org URLs
- Simplify distribution-detection
- Don't use macros in paths for build-time commands, hardcode them instead
- Unconditionally remove buildroot in %%clean and %%install

* Tue Oct  4 2005 Paul Howarth <paul@city-fan.org> - 2.00-1
- Update to 2.00
- Remove redundant find of empty .bs files
- Fix directory ownership
- Add BR's perl(Test::Pod), perl(Test::Pod::Coverage)

* Fri Jun 24 2005 Paul Howarth <paul@city-fan.org> - 1.30-3
- Change Conflicts: to Obsoletes: (D'oh!)

* Fri Jun 24 2005 Paul Howarth <paul@city-fan.org> - 1.30-2
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Fix URL
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Remove MANIFEST from %%doc
- Add Provides: weblint

* Tue Feb  1 2005 Paul Howarth <paul@city-fan.org> - 1.30-1
- Tidy up spec file
- Update to 1.30

* Mon May 10 2004 Paul Howarth <paul@city-fan.org> - 1.28-1
- Initial build
